

extern void 		lcd_4bus_write(uint8_t data);//   4  ,   RS=RW=0,  DB3..0 = 0    Z   
extern uint8_t 	lcd_read_byte(void);//   4  //  .  PORTLCD 4    //  , RS=RW=0,  DB3..0 = 0    Z    
extern uint8_t 	read_busy_address(void);
extern void 		lcd_write_data(uint8_t data);//write data to CGRAM or DDRAM
extern uint8_t 	lcd_read_data(void);//read data from CGRAM or DDRAM
extern void 		lcd_instructions_set(uint8_t address);
extern void 		lcd_init(void);
extern void		lcd_set_address(uint8_t x, uint8_t y);
void 				sig_E(void);// strob
void 				function_set_8bit(void);//   . lcd_init()

//extern void main2(void);

//      lcd; 7,    (--).
#define PORTLCD PORTD
#define DDRLCD	DDRD
#define PINLCD	PIND

#define E	_BV(4)//4
#define RW	_BV(5)//5
#define RS	_BV(6)//6
#define DB7	_BV(3)//3
#define DB6	_BV(2)//2
#define DB5	_BV(1)//1
#define DB4	_BV(0)//0
//#define DB3	_BV(3)
//#define DB2	_BV(2)
//#define DB1	_BV(1)
//#define DB0	_BV(0)


//  lcd  !    
#define busy_flag					0x80
#define clear_display				0x01 //1.5mS  .       
#define return_home					0x02 //40uS     
//---------Entry mode set--------------- //40uS        
#define	inc_AC						0x06
#define inc_AC_display_shift_richt	0x05
#define dec_AC						0x04
#define dec_AC_display_shift_left	0x07
//---------Display control--------------
#define display_off					0x08
#define display_on					0x0C
#define cursor_off					0x0C		
#define cursor_lines				0x0E
#define cursor_lin_blinks			0x0F 
#define cursor_blinks				0x0D 
//---------Cursor/display shift---------
#define shift_cursor_left			0x10
#define shift_cursor_richt			0x14
#define shift_display_left			0x18
#define shift_display_richt			0x1C
//--------------Function set------------
//--------------------------------------

#define set_cgram_address				0x40 //max 63
#define set_ddram_address				0x80 //max 127

